Groups in EJ2 JavaScript TextBox

21 Aug 202621 minutes to read

The following section explains you the steps required to create TextBox with icon and floating label.

TextBox:

  • Create a parent div element with the class e-input-group

  • Place input element with the class e-input inside the parent div element.

<div>
      <!--element which is going to render the TextBox-->
      <input id="firstName"/>
    </div>
```
    import { TextBox } from '@syncfusion/ej2-inputs'

    let inputobj: TextBox = new TextBox({
        placeholder: 'Enter Date',
    });

inputobj.appendTo('#firstName');
```

Floating label:

  • Add the e-float-input class to the parent div element.

  • Remove the e-input class and add required attribute to the input element.

  • Place the span element with class e-float-line after the input element.

  • Place the label element with class e-float-text after the above created span element. When you focus or filled with value in the TextBox, the label floats above the TextBox.

Creating the Floating label TextBox, you have to set the required attribute to the Input element to achieve the floating label functionality which is used for validating the value existence in TextBox. If you want to render the Floating label TextBox without
required attribute then refer to the Floating label without required attribute section.

<div>
      <!--element which is going to render the TextBox-->
      <input id="firstName"/>
    </div>
```
    import { TextBox } from '@syncfusion/ej2-inputs'

    let inputobj: TextBox = new TextBox({
        placeholder: 'Enter the name',
        floatLabelType: 'Auto'
    });

inputobj.appendTo('#firstName');
```

And refer to the following sections to add the icons to the TextBox.

With icon and floating label

Create an icon element as a span with the class e-input-group-icon, and the user can place the icon in either side of TextBox by adding the created icon element before/after the input.

For the floating label enabled TextBox add the icon element as first or last element inside the TextBox wrapper, and based on the element position it will act as prefix or suffix icon.

// First TextBox without an icon
let textIconAppend = new ej.inputs.TextBox({
    placeholder: 'Enter Date',
    created: () => {
      textIconAppend.addIcon('append', 'e-date-icon');
    },
  });
  textIconAppend.appendTo('#textIconAppend');
  
  // Second TextBox with an icon
  let textIconPrepend = new ej.inputs.TextBox({
    placeholder: 'Enter Date',
    created: () => {
      textIconPrepend.addIcon('prepend', 'e-date-icon');
    },
  });
  textIconPrepend.appendTo('#textIconPrepend');
  
  let textIconAppendPrepend = new ej.inputs.TextBox({
    placeholder: 'Enter Date',
    created: () => {
      textIconAppendPrepend.addIcon('prepend', 'e-date-icon');
      textIconAppendPrepend.addIcon('append', 'e-chevron-down-fill');
    },
  });
  textIconAppendPrepend.appendTo('#textIconAppendPrepend');
  
  // First TextBox without an icon
  let textFloatIconAppend = new ej.inputs.TextBox({
    placeholder: 'Enter Date',
    floatLabelType: 'Auto',
    created: () => {
      textFloatIconAppend.addIcon('append', 'e-date-icon');
    },
  });
  textFloatIconAppend.appendTo('#textFloatIconAppend');
  
  // Second TextBox with an icon
  let textFloatIconPrepend = new ej.inputs.TextBox({
    placeholder: 'Enter Date',
    floatLabelType: 'Auto',
    created: () => {
      textFloatIconPrepend.addIcon('prepend', 'e-date-icon');
    },
  });
  textFloatIconPrepend.appendTo('#textFloatIconPrepend');
  
  let textFloatIconAppendPrepend = new ej.inputs.TextBox({
    placeholder: 'Enter Date',
    floatLabelType: 'Auto',
    created: () => {
      textFloatIconAppendPrepend.addIcon('prepend', 'e-date-icon');
      textFloatIconAppendPrepend.addIcon('append', 'e-chevron-down-fill');
    },
  });
  textFloatIconAppendPrepend.appendTo('#textFloatIconAppendPrepend');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 TextBox</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 TextBox Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-inputs/styles/material.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>
<body>
    <div id='loader'>Loading....</div>
    <div id='container'>
        <div class='wrap'>
          <div id="input-container">



            <h4>TextBox with icons</h4>

            <div>
              <input id="textIconAppend" />
            </div>
    
            <div>
              <input id="textIconPrepend" />
            </div>
    
            <div>
              <input id="textIconAppendPrepend" />
            </div>
    
            <h4>Floating label with icons</h4>
    
            <div>
              <input id="textFloatIconAppend" />
            </div>
    
            <div>
              <input id="textFloatIconPrepend" />
            </div>
    
            <div>
              <input id="textFloatIconAppendPrepend" />
            </div>



          </div>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}

.e-chevron-down-fill:before {
  content: '\e70d';
}

To place the icon on left side of the TextBox, create a div element with the class e-input-in-wrap as wrapper to the input element and place the floating line, floating text, and right side icon element within it. Add the e-float-icon-left class to the TextBox container element.

With clear button and floating label

The clear button is added to the input for clearing the value given in the TextBox. It is shown only when the input field has a value, otherwise not shown.

You can add the clear button to the TextBox by enabling the showClearButton API in textbox

var inputobj = new ej.inputs.TextBox({
        placeholder: 'First Name',
        floatLabelType: 'Never'
    });
inputobj.appendTo('#firstName');


var inputobj1 = new ej.inputs.TextBox({
        placeholder: 'Last Name',
        floatLabelType: 'Auto'
    });
inputobj.appendTo('#lastName');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 TextBox</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 TextBox Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-inputs/styles/material.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>
<body>
    <div id='loader'>Loading....</div>
    <div id='container'>
        <div class='wrap'>
          <div id="input-container" class="textboxes">


            <h4> Textbox with clear icon</h4>
            <input id="firstName"/>
          </div>
          <div id="input-container" class="textboxes">
                <h4>Floating Textbox with clear icon</h4>
                <input id="lastName"/>
            </div>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 30px 10px;
  width: 260px;
}

.textboxes {
  margin-top: 15px;
}

Floating label without required attribute

You can render the Floating label TextBox without required attribute by manually float the label above of the TextBox using input events.
You can manually float the label above of the TextBox by adding the below list of classes to the floating label element. The classes are:

Class Name Description
e-label-top Floats the label above of the TextBox.
e-label-bottom Label to be placed as placeholder for the TextBox.
ej.base.enableRipple(true);

var inputObj = new ej.inputs.TextBox({
    placeholder: 'Enter the name',
    floatLabelType: 'Auto',
  });
  inputObj.appendTo('#input1');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 TextBox</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 TextBox Components">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="wrap">
          <div id="input-container">
            <h4> Floating label without required attribute </h4>
            <div class="e-float-input">
                <input id="input1">
            </div>
          </div>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 260px;
}

Multi-line input with floating label

Add the HTML textarea element with the e-input class to create default multi-line input.

Add the floating label support to the multi-line input by creating the floating label structure as defined in the initial section.

ej.base.enableRipple(true);

var textBoxObj = new ej.inputs.TextBox({
    placeholder: 'Enter address',
    multiline: true,
  });
  textBoxObj.appendTo('#input1');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 TextBox</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 TextBox Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-inputs/styles/material.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>
<body>
    <div id='loader'>Loading....</div>
    <div id='container'>
        <div class='wrap'>
          <div id="input-container">



    <textarea class="e-input"> Address </textarea>

    <div class="e-float-input">
        <textarea required></textarea>
        <span class="e-float-line"></span>
        <label class="e-float-text"> Address </label>
    </div>




          </div>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 260px;
}

#input-container .e-float-input { /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

See Also

Groups in Vue TextBox

20 Aug 202624 minutes to read

The following section explains you the steps required to create TextBox with icon and floating label.

TextBox:

  • Create a parent div element with the class e-input-group

  • Place input element with the class e-input inside the parent div element.

      <div class="e-input-group">
            <input class="e-input" name='input' type="text" placeholder="Enter Date"/>
      </div>

Floating label:

  • Add the e-float-input class to the parent div element.

  • Remove the e-input class and add required attribute to the input element.

  • Place the span element with class e-float-line after the input element.

  • Place the label element with class e-float-text after the above created span element. When you focus or filled with value in the TextBox, the label floats above the TextBox.

Creating the Floating label TextBox, you have to set the required attribute to the Input element to achieve the floating label functionality which is used for validating the value existence in TextBox. If you want to render the Floating label TextBox without required attribute then refer to the Floating label without required attribute section.

        <div class="e-float-input e-input-group">
            <input type="text" required/>
            <span class="e-float-line"></span>
            <label class="e-float-text">Enter Name </label>
        </div>

And refer to the following sections to add the icons to the TextBox.

With icon and floating label

Create an icon element as a span with the class e-input-group-icon, and the user can place the icon in either side of TextBox by adding the created icon element before/after the input.

For the floating label enabled TextBox add the icon element as first or last element inside the TextBox wrapper, and based on the element position it will act as prefix or suffix icon.

<template>
  <div class='wrap'>
    <div id='input-container'>
      <h4> TextBox with icons </h4>
      <div class="e-input-group">
        <input class="e-input" type="text" placeholder="Enter Date" />
        <span class="e-input-group-icon e-input-popup-date"></span>
      </div>

      <div class="e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input class="e-input" type="text" placeholder="Enter Date" />
        </div>
      </div>

      <div class="e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input class="e-input" type="text" placeholder="Enter Date" />
          <span class="e-input-group-icon e-input-down"></span>
        </div>
      </div>

      <h4> Floating label with icons </h4>

      <div class="e-float-input e-input-group">
        <input required type="text" />
        <span class="e-float-line"></span>
        <label class="e-float-text"> Enter Date </label>
        <span class="e-input-group-icon e-input-popup-date"></span>
      </div>

      <div class="e-float-input e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input required type="text" />
          <span class="e-float-line"></span>
          <label class="e-float-text"> Enter Date </label>
        </div>
      </div>

      <div class="e-float-input e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input required type="text" />
          <span class="e-float-line"></span>
          <label class="e-float-text"> Enter Date </label>
          <span class="e-input-group-icon e-input-down"></span>
        </div>
      </div>
    </div>
  </div>
</template>
<script setup>
import { onMounted } from 'vue';

onMounted(() => {
  // To get the all input fields and its container.

  let inputElement = document.querySelectorAll('.e-input-group .e-input,.e-float-input.e-input-group input');

  // Add 'e-input-focus' class to the input for achive ripple effect when focus on the input field.

  for (let i = 0; i < inputElement.length; i++) {
    inputElement[i].addEventListener("focus", function () {
      let parentElement = inputElement[i].parentNode;
      if (parentElement.classList.contains('e-input-in-wrap')) {
        parentElement.parentNode.classList.add('e-input-focus');
      } else {
        inputElement[i].parentNode.classList.add('e-input-focus');
      }
    });
    inputElement[i].addEventListener("blur", function () {
      let parentElement = inputElement[i].parentNode;
      if (parentElement.classList.contains('e-input-in-wrap')) {
        parentElement.parentNode.classList.remove('e-input-focus');
      } else {
        inputElement[i].parentNode.classList.remove('e-input-focus');
      }
    });
  }

  // Add 'e-input-btn-ripple' class to the icon element for achive ripple effect when click on the icon.

  var inputIcon = document.querySelectorAll('.e-input-group-icon');
  for (let i = 0; i < inputIcon.length; i++) {
    inputIcon[i].addEventListener('mousedown', function () {
      inputElement[i].classList.add('e-input-btn-ripple');
    });
    inputIcon[i].addEventListener('mouseup', function () {
       
      setTimeout(function () {
        inputIcon[i].classList.remove('e-input-btn-ripple');
      }, 500);
    });
  }
});
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}

#input-container .e-input-group {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

#input-container .e-float-input {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

.e-input-group-icon:before {
  font-family: e-icons;
}

.e-input-group .e-input-group-icon.e-input-popup-date {
  /* csslint allow: adjoining-classes */
  font-size: 16px;
}

.e-input-group.e-small .e-input-group-icon.e-input-popup-date {
  /* csslint allow: adjoining-classes */
  font-size: 14px;
}

.e-input-group-icon.e-input-popup-date:before {
  /* csslint allow: adjoining-classes */
  content: "";
}

.e-input-group-icon.e-input-up:before {
  /* csslint allow: adjoining-classes */
  content: '\e85e';
}

.e-input-group-icon.e-input-down:before {
  /* csslint allow: adjoining-classes */
  content: "";
}

.e-input-group-icon.e-input-plus:before {
  /* csslint allow: adjoining-classes */
  content: '\e7ba';
}

.e-input-group-icon.e-input-minus:before {
  /* csslint allow: adjoining-classes */
  content: '\e814';
}

.e-input-group-icon.e-input-date:before {
  /* csslint allow: adjoining-classes */
  content: "";
}

.e-input-group-icon.e-input-left:before {
  /* csslint allow: adjoining-classes */
  content: '\e904';
}

.e-input-group-icon.e-input-right:before {
  /* csslint allow: adjoining-classes */
  content: '\e913';
}

.e-input-group-icon.e-input-reload:before {
  /* csslint allow: adjoining-classes */
  content: '\e837';
}

.e-input-group-icon.e-input-search:before {
  /* csslint allow: adjoining-classes */
  content: '\e806';
}
</style>
<template>
  <div class='wrap'>
    <div id='input-container'>
      <h4> TextBox with icons </h4>
      <div class="e-input-group">
        <input class="e-input" type="text" placeholder="Enter Date" />
        <span class="e-input-group-icon e-input-popup-date"></span>
      </div>

      <div class="e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input class="e-input" type="text" placeholder="Enter Date" />
        </div>
      </div>

      <div class="e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input class="e-input" type="text" placeholder="Enter Date" />
          <span class="e-input-group-icon e-input-down"></span>
        </div>
      </div>

      <h4> Floating label with icons </h4>

      <div class="e-float-input e-input-group">
        <input required type="text" />
        <span class="e-float-line"></span>
        <label class="e-float-text"> Enter Date </label>
        <span class="e-input-group-icon e-input-popup-date"></span>
      </div>

      <div class="e-float-input e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input required type="text" />
          <span class="e-float-line"></span>
          <label class="e-float-text"> Enter Date </label>
        </div>
      </div>

      <div class="e-float-input e-input-group e-float-icon-left">
        <span class="e-input-group-icon e-input-date"></span>
        <div class="e-input-in-wrap">
          <input required type="text" />
          <span class="e-float-line"></span>
          <label class="e-float-text"> Enter Date </label>
          <span class="e-input-group-icon e-input-down"></span>
        </div>
      </div>
    </div>
  </div>
</template>
<script>

export default {
  data: function () {
    return {}
  },
  mounted: function () {
    // To get the all input fields and its container.

    let inputElement = document.querySelectorAll('.e-input-group .e-input,.e-float-input.e-input-group input');

    // Add 'e-input-focus' class to the input for achive ripple effect when focus on the input field.

    for (let i = 0; i < inputElement.length; i++) {
      inputElement[i].addEventListener("focus", function () {
        let parentElement = this.parentNode;
        if (parentElement.classList.contains('e-input-in-wrap')) {
          parentElement.parentNode.classList.add('e-input-focus');
        } else {
          this.parentNode.classList.add('e-input-focus');
        }
      });
      inputElement[i].addEventListener("blur", function () {
        let parentElement = this.parentNode;
        if (parentElement.classList.contains('e-input-in-wrap')) {
          parentElement.parentNode.classList.remove('e-input-focus');
        } else {
          this.parentNode.classList.remove('e-input-focus');
        }
      });
    }

    // Add 'e-input-btn-ripple' class to the icon element for achive ripple effect when click on the icon.

    var inputIcon = document.querySelectorAll('.e-input-group-icon');
    for (let i = 0; i < inputIcon.length; i++) {
      inputIcon[i].addEventListener('mousedown', function () {
        this.classList.add('e-input-btn-ripple');
      });
      inputIcon[i].addEventListener('mouseup', function () {
        let element = this;
        setTimeout(function () {
          element.classList.remove('e-input-btn-ripple');
        }, 500);
      });
    }
  },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}

#input-container .e-input-group {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

#input-container .e-float-input {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

.e-input-group-icon:before {
  font-family: e-icons;
}

.e-input-group .e-input-group-icon.e-input-popup-date {
  /* csslint allow: adjoining-classes */
  font-size: 16px;
}

.e-input-group.e-small .e-input-group-icon.e-input-popup-date {
  /* csslint allow: adjoining-classes */
  font-size: 14px;
}

.e-input-group-icon.e-input-popup-date:before {
  /* csslint allow: adjoining-classes */
  content: "";
}

.e-input-group-icon.e-input-up:before {
  /* csslint allow: adjoining-classes */
  content: '\e85e';
}

.e-input-group-icon.e-input-down:before {
  /* csslint allow: adjoining-classes */
  content: "";
}

.e-input-group-icon.e-input-plus:before {
  /* csslint allow: adjoining-classes */
  content: '\e7ba';
}

.e-input-group-icon.e-input-minus:before {
  /* csslint allow: adjoining-classes */
  content: '\e814';
}

.e-input-group-icon.e-input-date:before {
  /* csslint allow: adjoining-classes */
  content: "";
}

.e-input-group-icon.e-input-left:before {
  /* csslint allow: adjoining-classes */
  content: '\e904';
}

.e-input-group-icon.e-input-right:before {
  /* csslint allow: adjoining-classes */
  content: '\e913';
}

.e-input-group-icon.e-input-reload:before {
  /* csslint allow: adjoining-classes */
  content: '\e837';
}

.e-input-group-icon.e-input-search:before {
  /* csslint allow: adjoining-classes */
  content: '\e806';
}
</style>

To place the icon on left side of the TextBox, create a div element with the class e-input-in-wrap as wrapper to the input element and place the floating line, floating text, and right side icon element within it. Add the e-float-icon-left class to the TextBox container element.

With clear button and floating label

The clear button is added to the input for clearing the value given in the TextBox. It is shown only when the input field has a value, otherwise not shown.

You can add the clear button to the TextBox by using showClearButton API

<template>
  <div class='wrap'>
    <div id='input-container'>
      <h4> TextBox with clear button </h4>
      <ejs-textbox id='textbox' floatLabelType="Never" showClearButton="true" placeholder="First Name"></ejs-textbox>
      <h4>Floating TextBox with clear button </h4>
      <ejs-textbox id='textbox' floatLabelType="Auto" showClearButton="true" placeholder="Last Name"></ejs-textbox>
    </div>
  </div>
</template>

<script setup>

import { TextBoxComponent as EjsTextbox } from '@syncfusion/ej2-vue-inputs';

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}
</style>
<template>
  <div class='wrap'>
    <div id='input-container'>
      <h4> TextBox with clear button </h4>
      <ejs-textbox id='textbox' floatLabelType="Never" showClearButton="true" placeholder="First Name"></ejs-textbox>
      <h4>Floating TextBox with clear button </h4>
      <ejs-textbox id='textbox' floatLabelType="Auto" showClearButton="true" placeholder="Last Name"></ejs-textbox>
    </div>
  </div>
</template>

<script>

import { TextBoxComponent } from '@syncfusion/ej2-vue-inputs';

export default {
  name: "App",
  components: {
    "ejs-textbox": TextBoxComponent
  },
  data: function () {
    return {}
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}
</style>

Floating label without required attribute

You can render the Floating label TextBox without required attribute by manually float the label above of the TextBox using input events.
You can manually float the label above of the TextBox by adding the below list of classes to the floating label element. The classes are:

Class Name Description
e-label-top Floats the label above of the TextBox.
e-label-bottom Label to be placed as placeholder for the TextBox.
<template>
  <div class='wrap'>
    <div id='input-container'>
      <h4> Floating label without required attribute </h4>
      <div class="e-float-input">
        <input type="text" id='inpt1' />
        <span class="e-float-line"></span>
        <label class="e-float-text"> Enter Value </label>
      </div>
    </div>
  </div>
</template>
<script setup>

import { onMounted } from 'vue';

onMounted(() => {
  /* To get the Input element */
  let inputElement = document.getElementById('inpt1');

  /* Update the label position based on Input value */
  updateLabelState(inputElement.value, inputElement.parentElement.querySelector('.e-float-text'));

  inputElement.addEventListener("focus", function () {
    let label = this.parentElement.querySelector('.e-float-text');
    label.classList.add('e-label-bottom');
    label.classList.remove('e-label-top');
  });

  inputElement.addEventListener("blur", function () {
    updateLabelState(this.value, this.parentElement.querySelector('.e-float-text'));
  });

  inputElement.addEventListener("input", function () {
    updateLabelState(this.value, this.parentElement.querySelector('.e-float-text'));
  });

  /* Update the label position based on Input value */

  /* e-label-top - Floats the label above of the TextBox */
  /* e-label-bottom - Label to be placed as placeholder for the TextBox */

  function updateLabelState(value, label) {
    if (value) {
      label.classList.add('e-label-top');
      label.classList.remove('e-label-bottom');
    } else {
      label.classList.add('e-label-bottom');
      label.classList.remove('e-label-top');
    }
  }
});
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}

#input-container .e-input-group {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

#input-container .e-float-input {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

.e-float-input.e-success label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #22b24b;
}

.e-float-input.e-success input:focus~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #22b24b;
}

.e-float-input.e-success input:valid~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #22b24b;
}

.e-float-input.e-warning label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #ffca1c;
}

.e-float-input.e-warning input:focus~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #ffca1c;
}

.e-float-input.e-warning input:valid~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #ffca1c;
}
</style>
<template>
  <div class='wrap'>
    <div id='input-container'>
      <h4> Floating label without required attribute </h4>
      <div class="e-float-input">
        <input type="text" id='inpt1' />
        <span class="e-float-line"></span>
        <label class="e-float-text"> Enter Value </label>
      </div>
    </div>
  </div>
</template>
<script>

export default {
  data: function () {
    return {}
  },
  mounted: function () {
    /* To get the Input element */
    let inputElement = document.getElementById('inpt1');

    /* Update the label position based on Input value */
    updateLabelState(inputElement.value, inputElement.parentElement.querySelector('.e-float-text'));

    inputElement.addEventListener("focus", function () {
      let label = this.parentElement.querySelector('.e-float-text');
      label.classList.add('e-label-bottom');
      label.classList.remove('e-label-top');
    });

    inputElement.addEventListener("blur", function () {
      updateLabelState(this.value, this.parentElement.querySelector('.e-float-text'));
    });

    inputElement.addEventListener("input", function () {
      updateLabelState(this.value, this.parentElement.querySelector('.e-float-text'));
    });

    /* Update the label position based on Input value */

    /* e-label-top - Floats the label above of the TextBox */
    /* e-label-bottom - Label to be placed as placeholder for the TextBox */

    function updateLabelState(value, label) {
      if (value) {
        label.classList.add('e-label-top');
        label.classList.remove('e-label-bottom');
      } else {
        label.classList.add('e-label-bottom');
        label.classList.remove('e-label-top');
      }
    }
  }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
  box-sizing: border-box;
  margin: 0 auto;
  padding: 20px 10px;
  width: 340px;
}

#input-container .e-input-group {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

#input-container .e-float-input {
  /* csslint allow: adjoining-classes */
  margin: 30px 0;
}

.e-float-input.e-success label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #22b24b;
}

.e-float-input.e-success input:focus~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #22b24b;
}

.e-float-input.e-success input:valid~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #22b24b;
}

.e-float-input.e-warning label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #ffca1c;
}

.e-float-input.e-warning input:focus~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #ffca1c;
}

.e-float-input.e-warning input:valid~label.e-float-text {
  /* csslint allow: adjoining-classes */
  color: #ffca1c;
}
</style>

Multi-line input with floating label

Add the HTML textarea element with the e-input class to create default multi-line input.

Add the floating label support to the multi-line input by creating the floating label structure as defined in the initial section.

<template>
    <div class='wrap'>
        <div id='input-container'>
            <textarea class="e-input"> Address </textarea>
            <div class="e-float-input">
                <textarea required></textarea>
                <span class="e-float-line"></span>
                <label class="e-float-text"> Address </label>
            </div>
        </div>
    </div>
</template>
<script setup>

import { onMounted } from 'vue';

onMounted(() => {
    let input = document.querySelectorAll('.e-input-group .e-input,.e-float-input.e-input-group input');
    let inputIcon = document.querySelectorAll('.e-input-group-icon');

    for (let i = 0; i < input.length; i++) {
        //Focus Event binding for input component
        input[i].addEventListener('focus', function () {
            getParentNode(input[i]).classList.add('e-input-focus');
        });
        //Blur Event binding for input component
        input[i].addEventListener('blur', function () {
            getParentNode(input[i]).classList.remove('e-input-focus');
        });
    }
    for (let i = 0; i < inputIcon.length; i++) {
        inputIcon[i].addEventListener('mousedown', function () {
            inputIcon[i].classList.add('e-input-btn-ripple');
        });
        inputIcon[i].addEventListener('mouseup', function () {
            setTimeout(function () {
                inputIcon[i].classList.remove('e-input-btn-ripple');
            },
                500);
        });
    }
});

const getParentNode = (element) => {
    let parentNode = element.parentNode;
    if (parentNode.classList.contains('e-input-in-wrap')) {
        return parentNode.parentNode;
    }
    return parentNode;
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
    box-sizing: border-box;
    margin: 0 auto;
    padding: 20px 10px;
    width: 340px;
}

#input-container .e-input-group {
    /* csslint allow: adjoining-classes */
    margin: 30px 0;
}

#input-container .e-float-input {
    /* csslint allow: adjoining-classes */
    margin: 30px 0;
}
</style>
<template>
    <div class='wrap'>
        <div id='input-container'>
            <textarea class="e-input"> Address </textarea>
            <div class="e-float-input">
                <textarea required></textarea>
                <span class="e-float-line"></span>
                <label class="e-float-text"> Address </label>
            </div>
        </div>
    </div>
</template>
<script>

export default {
    data: function () {
        return {}
    },
    mounted: function () {
        let input = document.querySelectorAll('.e-input-group .e-input,.e-float-input.e-input-group input');
        let inputIcon = document.querySelectorAll('.e-input-group-icon');
        let localObj = this;
        for (let i = 0; i < input.length; i++) {
            //Focus Event binding for input component
            input[i].addEventListener('focus', function () {
                localObj.getParentNode(input[i]).classList.add('e-input-focus');
            });
            //Blur Event binding for input component
            input[i].addEventListener('blur', function () {
                localObj.getParentNode(input[i]).classList.remove('e-input-focus');
            });
        }
        for (let i = 0; i < inputIcon.length; i++) {
            inputIcon[i].addEventListener('mousedown', function () {
                this.classList.add('e-input-btn-ripple');
            });
            inputIcon[i].addEventListener('mouseup', function () {
                let ele = this;
                setTimeout(function () {
                    ele.classList.remove('e-input-btn-ripple');
                },
                    500);
            });
        }

    },
    methods: {
        getParentNode: function (element) {
            let parentNode = element.parentNode;
            if (parentNode.classList.contains('e-input-in-wrap')) {
                return parentNode.parentNode;
            }
            return parentNode;
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

.wrap {
    box-sizing: border-box;
    margin: 0 auto;
    padding: 20px 10px;
    width: 340px;
}

#input-container .e-input-group {
    /* csslint allow: adjoining-classes */
    margin: 30px 0;
}

#input-container .e-float-input {
    /* csslint allow: adjoining-classes */
    margin: 30px 0;
}
</style>

See Also

Groups in React TextBox

Create an enhanced React TextBox with floating labels and icons to improve the visual clarity and user experience of your form inputs. The following sections explain the steps to implement these features.

Floating label

Add floating labels to your React TextBox using the FloatLabelType property. This property controls how the placeholder text animates when the input is focused or contains a value. Supported values include:

  • Never - The placeholder text should not be float ever.
  • Always - The placeholder text floats above the TextBox always.
  • Auto - The placeholder text floats above the TextBox while focusing or enter a value in TextBox.

[Class-component]

import * as React from "react";
import './App.css';
export default class App extends React.Component<{}, {}> {
    public render() {
      return (
        // element which is going to render the Floating TextBox
        <TextBoxComponent placeholder="Enter Name" floatLabelType="Auto"></TextBoxComponent>
      );
    }
};

[Functional-component]

import * as React from "react";
import * as ReactDOM from 'react-dom';
import './App.css';

function App() {
    return (
        // element which is going to render the Floating TextBox
       <TextBoxComponent placeholder="Enter Name" floatLabelType="Auto"></TextBoxComponent>
    );
}
ReactDOM.render(<App />, document.getElementById('input-container'));

And refer to the following sections to add the icons to the React TextBox.

With icon and floating label

Create an icon in the React TextBox using the addIcon method and enable the float label using the FloatLabelType property. The user can place the icon on either side of the React TextBox by specifying “append” or “prepend” in the addIcon method.

[Class-component]

import * as React from "react";
import './index.css';
import * as ReactDOM from "react-dom";
import { createRoot } from 'react-dom/client';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
export default class Default extends React.Component {
    textBoxObj = React.createRef();
    textBoxObj1 = React.createRef();
    textBoxObj2 = React.createRef();
    textBoxObj3 = React.createRef();
    textBoxObj4 = React.createRef();
    textBoxObj5 = React.createRef();
    oncreate = () => {  
        this.textBoxObj.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    oncreated = () => {  
        this.textBoxObj1.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    oncreateHandle = () => {  
        this.textBoxObj2.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj2.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    ontextcreate = () => {  
        this.textBoxObj3.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    ontextcreated = () => {  
        this.textBoxObj4.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    ontextcreateHandle = () => {  
        this.textBoxObj5.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj5.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }

    render() {
        return (<div>

    <h4> TextBox with icons </h4>

    <TextBoxComponent
        id='default'
        placeholder="Enter Date"
        ref={this.textBoxObj}
        created={this.oncreate}
    />

    <TextBoxComponent
        id='textboxObj'
        placeholder="Enter Date"
        ref={this.textBoxObj1}
        created={this.oncreated}
    />

    <TextBoxComponent
        id='textObj'
        placeholder="Enter Date"
        ref={this.textBoxObj2}
        created={this.oncreateHandle}
    />

    <h4> Floating label with icons </h4>

    <TextBoxComponent
        id='floatdefault'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj3}
        created={this.ontextcreate}
    />

    <TextBoxComponent
        id='floattextboxObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj4}
        created={this.ontextcreated}
    />

    <TextBoxComponent
        id='floattextObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj5}
        created={this.ontextcreateHandle}
    />
        </div>);
    } 
}
ReactDOM.render(<Default />, document.getElementById('input-container'));
import * as React from "react";
import './index.css';
import * as ReactDOM from "react-dom";
import { createRoot } from 'react-dom/client';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
export default class Default extends React.Component {
    public textBoxObj = React.createRef();
    public textBoxObj1 = React.createRef();
    public textBoxObj2 = React.createRef();
    public textBoxObj3 = React.createRef();
    public textBoxObj4 = React.createRef();
    public textBoxObj5 = React.createRef();
    public oncreate() {  
        this.textBoxObj.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    public oncreated() {  
        this.textBoxObj1.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    public oncreateHandle() {  
        this.textBoxObj2.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj2.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    public ontextcreate() {  
        this.textBoxObj3.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    public ontextcreated() {  
        this.textBoxObj4.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    public ontextcreateHandle() {  
        this.textBoxObj5.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj5.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }

    public render() {
        return (<div>

    <h4> TextBox with icons </h4>

    <TextBoxComponent
        id='default'
        placeholder="Enter Date"
        ref={this.textBoxObj}
        created={this.oncreate}
    />

    <TextBoxComponent
        id='textboxObj'
        placeholder="Enter Date"
        ref={this.textBoxObj1}
        created={this.oncreated}
    />

    <TextBoxComponent
        id='textObj'
        placeholder="Enter Date"
        ref={this.textBoxObj2}
        created={this.oncreateHandle}
    />

    <h4> Floating label with icons </h4>

    <TextBoxComponent
        id='floatdefault'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj3}
        created={this.ontextcreate}
    />

    <TextBoxComponent
        id='floattextboxObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj4}
        created={this.ontextcreated}
    />

    <TextBoxComponent
        id='floattextObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj5}
        created={this.ontextcreateHandle}
    />
        </div>);
    } 
}
ReactDOM.render(<Default />, document.getElementById('input-container'));

[Functional-component]

import * as React from "react";
import './index.css';
import * as ReactDOM from "react-dom";
import { createRoot } from 'react-dom/client';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
export default class Default extends React.Component {
    textBoxObj = React.createRef();
    textBoxObj1 = React.createRef();
    textBoxObj2 = React.createRef();
    textBoxObj3 = React.createRef();
    textBoxObj4 = React.createRef();
    textBoxObj5 = React.createRef();
    oncreate = () => {  
        this.textBoxObj.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    oncreated = () => {  
        this.textBoxObj1.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    oncreateHandle = () => {  
        this.textBoxObj2.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj2.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    ontextcreate = () => {  
        this.textBoxObj3.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    ontextcreated = () => {  
        this.textBoxObj4.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    ontextcreateHandle = () => {  
        this.textBoxObj5.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj5.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }

    render() {
        return (<div>

    <h4> TextBox with icons </h4>

    <TextBoxComponent
        id='default'
        placeholder="Enter Date"
        ref={this.textBoxObj}
        created={this.oncreate}
    />

    <TextBoxComponent
        id='textboxObj'
        placeholder="Enter Date"
        ref={this.textBoxObj1}
        created={this.oncreated}
    />

    <TextBoxComponent
        id='textObj'
        placeholder="Enter Date"
        ref={this.textBoxObj2}
        created={this.oncreateHandle}
    />

    <h4> Floating label with icons </h4>

    <TextBoxComponent
        id='floatdefault'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj3}
        created={this.ontextcreate}
    />

    <TextBoxComponent
        id='floattextboxObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj4}
        created={this.ontextcreated}
    />

    <TextBoxComponent
        id='floattextObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj5}
        created={this.ontextcreateHandle}
    />
        </div>);
    } 
}
ReactDOM.render(<Default />, document.getElementById('input-container'));
import * as React from "react";
import './index.css';
import * as ReactDOM from "react-dom";
import { createRoot } from 'react-dom/client';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
export default class Default extends React.Component {
    public textBoxObj = React.createRef();
    public textBoxObj1 = React.createRef();
    public textBoxObj2 = React.createRef();
    public textBoxObj3 = React.createRef();
    public textBoxObj4 = React.createRef();
    public textBoxObj5 = React.createRef();
    public oncreate() {  
        this.textBoxObj.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    public oncreated() {  
        this.textBoxObj1.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    public oncreateHandle() {  
        this.textBoxObj2.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj2.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    public ontextcreate() {  
        this.textBoxObj3.current.addIcon('append', 'e-icons e-input-popup-date');
    }
    public ontextcreated() {  
        this.textBoxObj4.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }
    public ontextcreateHandle() {  
        this.textBoxObj5.current.addIcon('append', 'e-icons e-input-down');
        this.textBoxObj5.current.addIcon('prepend', 'e-icons e-input-popup-date');
    }

    public render() {
        return (<div>

    <h4> TextBox with icons </h4>

    <TextBoxComponent
        id='default'
        placeholder="Enter Date"
        ref={this.textBoxObj}
        created={this.oncreate}
    />

    <TextBoxComponent
        id='textboxObj'
        placeholder="Enter Date"
        ref={this.textBoxObj1}
        created={this.oncreated}
    />

    <TextBoxComponent
        id='textObj'
        placeholder="Enter Date"
        ref={this.textBoxObj2}
        created={this.oncreateHandle}
    />

    <h4> Floating label with icons </h4>

    <TextBoxComponent
        id='floatdefault'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj3}
        created={this.ontextcreate}
    />

    <TextBoxComponent
        id='floattextboxObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj4}
        created={this.ontextcreated}
    />

    <TextBoxComponent
        id='floattextObj'
        placeholder="Enter Date"
        floatLabelType="Auto"
        ref={this.textBoxObj5}
        created={this.ontextcreateHandle}
    />
        </div>);
    } 
}
ReactDOM.render(<Default />, document.getElementById('input-container'));

With clear button and floating label

The clear button is added to the input for clearing the value given in the TextBox. It is shown only when the input field has a value, otherwise not shown.

You can add the clear button to the TextBox by using showClearButton API in React TextBox.

[Class-component]

import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component {
    render() {
        return (<div className="App">
                <div className="textboxes">
                    <h4>Textbox with clear button</h4>
                    <TextBoxComponent placeholder="First Name" showClearButton={true} floatLabelType="Never"/>
                </div>
                <div className="textboxes">
                    <h4>Floating textbox with clear button</h4>
                    <TextBoxComponent placeholder="Last Name" showClearButton={true} floatLabelType="Auto"/>
                </div>
            </div>);
    }
}
;
ReactDOM.render(<App />, document.getElementById('input-container'));
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component<{}, {}> {
    public render() {
        return (
              <div className="App">
                <div className="textboxes">
                    <h4>Textbox with clear button</h4>
                    <TextBoxComponent placeholder="First Name" showClearButton= {true} floatLabelType="Never"/>
                </div>
                <div className="textboxes">
                    <h4>Floating textbox with clear button</h4>
                    <TextBoxComponent placeholder="Last Name" showClearButton= {true} floatLabelType="Auto"/>
                </div>
            </div>
        )
    }
};

ReactDOM.render(<App />, document.getElementById('input-container'));

[Functional-component]

import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import * as React from "react";
import * as ReactDOM from "react-dom";
function App() {
    return (<div className="App">
            <div className="textboxes">
                <h4>Textbox with clear button</h4>
                <TextBoxComponent placeholder="First Name" showClearButton={true} floatLabelType="Never"/>
            </div>
            <div className="textboxes">
                <h4>Floating textbox with clear button</h4>
                <TextBoxComponent placeholder="Last Name" showClearButton={true} floatLabelType="Auto"/>
            </div>
        </div>);
}
ReactDOM.render(<App />, document.getElementById('input-container'));
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import * as React from "react";
import * as ReactDOM from "react-dom";

function App() {
    return (
            <div className="App">
            <div className="textboxes">
                <h4>Textbox with clear button</h4>
                <TextBoxComponent placeholder="First Name" showClearButton= {true} floatLabelType="Never"/>
            </div>
            <div className="textboxes">
                <h4>Floating textbox with clear button</h4>
                <TextBoxComponent placeholder="Last Name" showClearButton= {true} floatLabelType="Auto"/>
            </div>
        </div>
    )
}

ReactDOM.render(<App />, document.getElementById('input-container'));

Multi-line input with floating label

To create a multiline input using the multiline API, it will act as a TextArea component. You can also resize the rows.

[Class-component]

import * as React from "react";
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
export default class App extends React.Component {
    render() {
        return (<TextBoxComponent
            id='default'
            placeholder="Address"
            floatLabelType="Auto"
            multiline="true"
        />);
    }
}
;
ReactDOM.render(<App />, document.getElementById('input-container'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
export default class App extends React.Component<{}, {}> {
    public render() {
        return (<TextBoxComponent
            id='default'
            placeholder="Address"
            floatLabelType="Auto"
            multiline="true"
        />
        )
    }
};

ReactDOM.render(<App />, document.getElementById('input-container'));

[Functional-component]

import * as React from "react";
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
function App() {
    return (<TextBoxComponent
        id='default'
        placeholder="Address"
        floatLabelType="Auto"
        multiline="true"
    />);
}
ReactDOM.render(<App />, document.getElementById('input-container'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
    function App() {
        return (
            <TextBoxComponent
                id='default'
                placeholder="Address"
                floatLabelType="Auto"
                multiline="true"
            />
        )
    }

ReactDOM.render(<App />, document.getElementById('input-container'));

See Also

TextBox Options in Angular TextBox

25 Sep 202613 minutes to read

The Syncfusion Angular TextBox component provides essential features to enhance user experience, including a built-in clear button for quick input reset and the ability to configure custom HTML attributes. This guide covers these primary features along with additional state management capabilities.

Add a Clear Button to the Angular TextBox

The Angular TextBox component includes a clear button feature that allows users to quickly reset the input value with a single click. The clear button automatically appears when the field contains text and disappears when the field is empty, providing a clean and intuitive user interface.

To enable the clear button functionality, set the showClearButton property to true.

import {TextBoxModule} from '@syncfusion/ej2-angular-inputs'
import { Component } from '@angular/core';

@Component({
imports: [
        
        TextBoxModule
    ],

standalone: true,
    selector: 'app-root',
    template: `<div class="wrap">
    <h4>Textbox with clear icon</h4>
    <div class='textboxes'>
        <ejs-textbox placeholder="First Name" showClearButton='true' floatLabelType="Never"></ejs-textbox>
    </div>

    <h4>Floating Textbox with clear icon</h4>
    <div class='textboxes'>
        <ejs-textbox placeholder="Last Name" showClearButton='true' floatLabelType="Auto"></ejs-textbox>
    </div>
    </div>`
})

export class AppComponent { }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Set HTML Attributes

The Angular TextBox component supports standard HTML attributes through the htmlAttributes property. This property accepts an object in which the keys represent attribute names and the values represent their corresponding values, allowing developers to add attributes such as name, type, maxlength, placeholder, title, and others directly to the input element.

When an attribute is configured through both a dedicated component property and the htmlAttributes object, the component prioritizes the dedicated property value.

The following example demonstrates how to configure common HTML attributes for a Angular TextBox:

import { Component } from '@angular/core';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';

@Component({
    imports: [TextBoxModule],
    standalone: true,
    selector: 'app-root',
    template: `
    <div style="margin-left: 25%; width: 240px; margin-top: 40px;">
        <h4>TextBox with HTML attributes</h4>
        <ejs-textbox [htmlAttributes]="htmlAttributes" placeholder="Enter password"></ejs-textbox>
    </div>
    `
})
export class AppComponent {
    public htmlAttributes: { [key: string]: string } = {
        name: 'userpassword',
        type: 'password',
        maxlength: '12',
        title: 'Enter your password'
    };
}

Configure Angular TextBox States

Set the Disabled State

To disable the Angular TextBox and prevent user interaction, set the enabled property to false.

import { Component } from '@angular/core';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';

@Component({
imports: [
        TextBoxModule
    ],
standalone: true,
    selector: 'app-root',
    template: `<div class="wrap">
                <ejs-textbox placeholder="Enter Name" [enabled]="false"></ejs-textbox>
                 <ejs-textbox placeholder="Enter Name" floatLabelType="Auto" [enabled]="false"></ejs-textbox>
              </div>`
})

export class AppComponent {
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Set the Read-Only State

Make the Angular TextBox read-only while maintaining its visual appearance and allowing text selection by setting the readonly property to true.

import { Component } from '@angular/core';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';

@Component({
imports: [
        TextBoxModule
    ],

standalone: true,
    selector: 'app-root',
    template: `<div class="wrap">
                <ejs-textbox placeholder="Enter Name" value="John" [readonly]="true"> </ejs-textbox>
                <ejs-textbox placeholder="Enter Name" floatLabelType="Auto" [readonly]="true"></ejs-textbox>
              </div>`
})

export class AppComponent {
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Angular TextBox Methods

Focus Management

Control the focus state of the Angular TextBox programmatically using the focus methods:

  • Use focusIn to set focus to the TextBox
  • Use focusOut to remove focus from the Angular TextBox
import { Component, ViewChild } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { TextBoxComponent, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    imports: [TextBoxModule, FormsModule, ButtonModule],
    standalone: true,
    selector: 'app-root',
    template: `
        <div class="wrap">
            <ejs-textbox #textbox placeholder="Enter Name" floatLabelType="Auto"></ejs-textbox>
            <button ejs-button (click)='focusHandler()'>Focus In</button>
            <button ejs-button (click)='blurHandler()'>Focus Out</button>
        </div>
    `
})
export class AppComponent {
    @ViewChild('textbox')
    public textboxObj?: TextBoxComponent;

    public focusHandler(): void {
        this.textboxObj?.focusIn();
    }

    public blurHandler(): void {
        this.textboxObj?.focusOut();
    }
}

Component Life cycle Methods

Destroy the Component

The destroy method removes the component from the DOM and detaches all event handlers while maintaining the original input element. This method is useful when dynamically removing TextBox components.

import { Component, ViewChild } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { TextBoxComponent, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    imports: [TextBoxModule, FormsModule, ButtonModule],
    standalone: true,
    selector: 'app-root',
    template: `
        <div class="wrap">
            <ejs-textbox #textbox placeholder="Enter Name" floatLabelType="Auto"></ejs-textbox>
            <button ejs-button (click)='destroyHandler()'>Destroy</button>
        </div>
    `
})
export class AppComponent {
    @ViewChild('textbox')
    public textboxObj?: TextBoxComponent;

    public destroyHandler(): void {
        this.textboxObj?.destroy();
    }
}

Get Persist Data

The getPersistData method returns the properties that should be maintained in the persisted state. Use this method when implementing custom persistence logic.

import { Component, ViewChild } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { TextBoxComponent, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    imports: [TextBoxModule, FormsModule, ButtonModule],
    standalone: true,
    selector: 'app-root',
    template: `
        <div class="wrap">
            <ejs-textbox #textbox placeholder="Enter Name" floatLabelType="Auto"></ejs-textbox>
            <button ejs-button (click)='getPersistDataHandler()'>Get Persist Data</button>
            <div></div>
        </div>
    `
})
export class AppComponent {
    @ViewChild('textbox')
    public textboxObj?: TextBoxComponent;
    public persistData: string|undefined;

    public getPersistDataHandler(): void {
        this.persistData = this.textboxObj?.getPersistData();
    }
}

Add TextBox Programmatically in Angular TextBox Component

Create the Angular TextBox component programmatically using the createInput method from the ej2-inputs library. This approach is useful when building dynamic forms or when textbox elements need to be generated based on runtime conditions.

Steps to Create Angular TextBox Programmatically

Follow these steps to create a TextBox component programmatically:

Step 1: Import the Input Module

Import the Input module from the ej2-inputs library as shown below.

import {Input} from '@syncfusion/ej2-inputs';

Step 2: Create the Angular TextBox Using createInput Method

Pass the HTML Input element as a parameter to the createInput method. This method transforms a standard HTML input element into a Syncfusion Angular TextBox component with enhanced styling and functionality.

Step 3: Add Icons (Optional)

Add icons to the input by passing the buttons property value with the class name e-input-group-icon as a parameter to the createInput method. This creates input groups with integrated icon buttons for enhanced user interaction.

Implementation Example

The following example demonstrates how to create Angular TextBox components programmatically with and without icons:

import { FormsModule } from '@angular/forms';
import { Component } from '@angular/core';
import { Input } from '@syncfusion/ej2-inputs';

@Component({
imports: [
        FormsModule
    ],

standalone: true,
    selector: 'app-root',
    template: `<div class="wrap">
                <input id="textbox" type="text" placeholder="Enter Name" />
                <input id="textbox-icon" type="text" />
               </div>`
})

export class AppComponent {
    ngOnInit() {
        let element: HTMLInputElement = document.getElementById('textbox') as HTMLInputElement;
        Input.createInput ({
            element: element
        });

        let element1: HTMLInputElement = document.getElementById('textbox-icon') as HTMLInputElement;
        Input.createInput ({
            element: element1,
            buttons: ['e-icons e-input-down'],
            properties: {
                placeholder:'Enter Value'
            }
        });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Use Cases

Programmatic Angular TextBox creation is particularly beneficial in the following scenarios:

  • Building dynamic forms where the number of input fields varies based on user selections
  • Creating input components in response to API data or configuration changes
  • Implementing custom form builders or survey applications
  • Adding TextBox elements to dynamically generated content areas